src/api/task/urls.py
from django.urls import path
from .views import TaskListViewSet, TaskCUDViewSet
from rest_framework import routers

router = routers.DefaultRouter()
router.register(r'task/list', TaskListViewSet, basename='task_list')
router.register(r'task', TaskCUDViewSet, basename='task')

urlpatterns = [
    path('user/task/<int:pk>', TaskListViewSet.as_view({'get': 'get_user_tasks'})),
    path('telegram/task/<int:telegram_id>', TaskListViewSet.as_view({'get': 'get_telegram_user_tasks'}))
]
urlpatterns += router.urls

src/apps/task/urls.py
from django.urls import path
from .views import (main, get_users_task,
                    single_task, delete_task,
                    create_task
                    )

urlpatterns = [
    path('', main, name='main'),
    path('user/tasks/<int:user_id>/', get_users_task, name='get_users_task'),
    path('tasks/<int:task_id>/', single_task, name='single_task'),
    path('tasks/create/', create_task, name='create_task'),
    path('tasks/delete/<int:task_id>/', delete_task, name='delete_task')
]

src/config/urls.py
from django.contrib import admin
from django.urls import path, include
from .yasg import urlpatterns as doc_urls

urlpatterns = [
    path('', include('apps.task.urls')),
    path('auth/', include('apps.account.urls')),
    path('auth/api/', include('api.auth.urls')),
    path('task/api/', include('api.task.urls')),
    path('admin/', admin.site.urls),
    path('__debug__/', include('debug_toolbar.urls')),
]

urlpatterns += doc_urls

src/apps/task/models.py
from django.db import models
from django.contrib.auth import get_user_model

User = get_user_model()

STATUS_TASK = (
    ('to_do', 'To do'),
    ('doing', 'Doing'),
    ('done', 'Done')
)


class Task(models.Model):
    """Объект для планирования задач"""
    user = models.ForeignKey(User, on_delete=models.CASCADE, related_name='user_tasks')
    title = models.CharField(max_length=100)
    description = models.TextField()
    date = models.DateTimeField(auto_now=True)
    status = models.CharField(choices=STATUS_TASK, default=STATUS_TASK[0][0], max_length=10)

    def __str__(self):
        return self.title

src/apps/task/forms.py
from django import forms
from .models import Task, STATUS_TASK
from django.contrib.auth import get_user_model

User = get_user_model()


class UpdateTaskForm(forms.ModelForm):
    status = forms.ChoiceField(choices=STATUS_TASK, widget=forms.Select(attrs={'class': 'form-control'}))
    title = forms.CharField(
        widget=forms.TextInput
        (attrs={'class': 'form-control'}))
    description = forms.CharField(
        widget=forms.Textarea
        (attrs={'class': 'form-control'}))

    class Meta:
        model = Task
        fields = ['status', 'title', 'description']


class CreateTaskForm(forms.ModelForm):
    user = forms.ModelChoiceField(queryset=User.objects.all(), widget=forms.Select(attrs={'class': 'form-control'}))
    title = forms.CharField(
        widget=forms.TextInput
        (attrs={'class': 'form-control'}))
    description = forms.CharField(
        widget=forms.Textarea
        (attrs={'class': 'form-control'}))

    class Meta:
        model = Task
        fields = ['user', 'title', 'description']

src/api/task/views.py
from apps.task.models import Task
from .serializers import ListTaskSerializer, TaskCRUDSerializer
from rest_framework.permissions import AllowAny
from rest_framework.response import Response
from ..base_mixin.viewset_mixins import CreateDestroyUpdateMixin, ReadOnlyMixin
from .service import TaskService


class TaskListViewSet(ReadOnlyMixin):
    queryset = Task.objects.all()
    permission_classes = [AllowAny, ]
    serializer_class = ListTaskSerializer

    def get_user_tasks(self, request, pk):
        data = TaskService.get_users_task_by_pk(pk)
        return Response(data)

    def get_telegram_user_tasks(self, request, telegram_id):
        data = TaskService.get_users_task_by_telegram_id(telegram_id)
        return Response(data)


class TaskCUDViewSet(CreateDestroyUpdateMixin):
    permission_classes = [AllowAny, ]
    queryset = Task.objects.all()
    serializer_class = TaskCRUDSerializer

src/apps/task/views.py
from django.shortcuts import render, redirect
from .models import Task
from .forms import UpdateTaskForm, CreateTaskForm
from django.contrib.auth import get_user_model
from django.http import Http404
from django.contrib import messages
from django.shortcuts import get_object_or_404

User = get_user_model()


def main(request):
    if request.user.is_authenticated:
        user_list = User.objects.all()
        return render(request, 'task/main.html', {'user_list': user_list})
    return redirect('login')


def get_users_task(request, user_id):
    user = User.objects.prefetch_related('user_tasks').filter(id=user_id).first()
    if user is not None:
        return render(request, 'task/users_tasks.html', {'user': user})
    return Http404()


def single_task(request, task_id):
    task = Task.objects.select_related('user').filter(id=task_id).first()
    if task is not None:
        if request.method == 'POST':
            form = UpdateTaskForm(instance=task, data=request.POST)
            if form.is_valid():
                form.save()
                messages.success(request, 'task is updated successfully!')
        form = UpdateTaskForm(instance=task)
        return render(request, 'task/single_task.html', {'form': form})
    return Http404()


def create_task(request):
    if request.method == 'POST':
        form = CreateTaskForm(data=request.POST)
        if form.is_valid():
            form.save()
            messages.success(request, 'created task')
        return redirect('main')
    form = CreateTaskForm()
    return render(request, 'task/create_task.html', {'form': form})


def delete_task(request, task_id):
    task = get_object_or_404(Task, id=task_id)
    task.delete()
    return redirect('main')

src/templates/task/create_task.html
{% extends 'base.html' %}
{% block body %}
{% include 'include/messages.html' %}

<form action="{% url 'create_task' %}" method="POST">
    {% csrf_token%}
    {{form.as_p}}
    <input type="submit" class="form-control btn btn-primary">
</form>

{% endblock %}

src/templates/task/main.html
{% extends 'base.html' %}
{% block body %}
<div class="list-group">
    {% for user in user_list%}
    <a href="{% url 'get_users_task' user.id %}" class="list-group-item list-group-item-action">{{user.username}}</a>
    {% endfor %}

</div>
{% endblock %}

src/templates/task/single_task.html
{% extends 'base.html' %}
{% block body %}
<form action="{% url 'single_task' form.instance.id %}" method="POST">
    {% csrf_token%}
    {{form.as_p}}
    <input type="submit" class="form-control btn btn-primary">
</form>

{% endblock %}

src/templates/task/task_list.html
{% extends 'base.html' %}
{% block body %}
{% for task in task_list %}
<div>{{task}}
    <button>Удалить</button>
    <button>Завершить</button>
</div>
{% endfor %}
{% endblock %}

src/templates/task/users_tasks.html
{% extends 'base.html' %}
{% block body %}
<table class="table">
    <thead>
    <tr>
        <th scope="col">No.</th>
        <th scope="col">Todo item</th>
        <th scope="col">Status</th>
        <th scope="col">Actions</th>
        <th scope="col">Actions</th>
    </tr>
    </thead>
    <tbody>
    {% for task in user.user_tasks.all%}
    <tr>
        <th scope="row">{{task.id}}</th>
        <td>{{task.title}}</td>
        <td>{{task.get_status_display}}</td>
        <td>
            <a href="{% url 'single_task' task.id %}" class="btn btn-success">Update</a>
        </td>
        <td>
            <a  class="btn btn-danger" href="{% url 'delete_task' task.id%}">Delete</a>
        </td>
    </tr>
    {% endfor %}
    </tbody>
</table>
{% endblock %}